
/*---------------------------------------------------------------------
Usage:

* Variable exists ;
%put EXISTS: %varexist(sashelp.class,age);  * returns varnum, i.e. 3 ;

* Variable does not exist ;
%put EXISTS: %varexist(sashelp.class,lastname);  * returns 0 ;

* Dataset does not exist ;
%put EXISTS: %varexist(class,name);  * returns 0 ;

* Variable attributes ;
%put VARNUM:   %varexist(sashelp.class,age,num);
%put LENGTH:   %varexist(sashelp.class,age,len);
%put FORMAT:   %varexist(sashelp.class,age,fmt);
%put INFORMAT: %varexist(sashelp.class,age,infmt);
%put LABEL:    %varexist(sashelp.class,age,label);
%put TYPE:     %varexist(sashelp.class,age,type);

-----------------------------------------------------------------------*/

options symbolgen mprint mlogic;
%macro varexist(data,var,info);
%local macro parmerr dsis rc varnum;
%let macro = &sysmacroname;
%let dsid = %sysfunc(open(&data));

%if (&dsid) %then %do;
   %let varnum = %sysfunc(varnum(&dsid,&var));

   %if (&varnum) %then %do;
      %if (%length(&info)) %then %do;
         %if (&info eq NUM) %then %do;
&varnum
         %end;
         %else %do;
%sysfunc(var&info(&dsid,&varnum))
         %end;
      %end;
      %else %do;
&varnum
      %end;
   %end;

   %else 0;

   %let rc = %sysfunc(close(&dsid));
%end;

%else 0;
%mend;

/******* END OF FILE *******/
%put EXISTS:   %varexist(sashelp.class,age); 
%put VARNUM:   %varexist(sashelp.class,age,num);
%put LENGTH:   %varexist(sashelp.class,age,len);
%put FORMAT:   %varexist(sashelp.air,date,fmt);
%put INFORMAT: %varexist(sashelp.class,age,infmt);
%put LABEL:    %varexist(sashelp.class,age,label);
%put TYPE:     %varexist(sashelp.class,age,type);


